booster::shared_ptr< T > Class Template Reference

## Public Types

typedef T | element_type
typedef T | value_type
typedef T * | pointer
typedef booster::detail::shared_ptr_traits < T >::reference | reference

## Public Member Functions

template<class Y >
| shared_ptr (Y *p)
template<class Y , class D >
| shared_ptr (Y *p, D d)
template<class Y , class D , class A >
| shared_ptr (Y *p, D d, A a)
template<class Y >
| shared_ptr (weak_ptr< Y > const &r)
template<class Y >
| shared_ptr (weak_ptr< Y > const &r, booster::detail::sp_nothrow_tag)
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, typename detail::sp_enable_if_convertible< Y, T >::type=detail::sp_empty())
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, T *p)
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, booster::detail::static_cast_tag)
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, booster::detail::const_cast_tag)
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, booster::detail::dynamic_cast_tag)
template<class Y >
| shared_ptr (shared_ptr< Y > const &r, booster::detail::polymorphic_cast_tag)
template<class Y >
| shared_ptr (std::auto_ptr< Y > &r)
template<class Ap >
| shared_ptr (Ap r, typename booster::detail::sp_enable_if_auto_ptr< Ap, int >::type=0)
shared_ptr & | operator= (shared_ptr const &r)
template<class Y >
shared_ptr & | operator= (shared_ptr< Y > const &r)
template<class Y >
shared_ptr & | operator= (std::auto_ptr< Y > &r)
template<class Ap >
booster::detail::sp_enable_if_auto_ptr < Ap, shared_ptr & >::type | operator= (Ap r)
void | reset ()
template<class Y >
void | reset (Y *p)
template<class Y , class D >
void | reset (Y *p, D d)
template<class Y , class D , class A >
void | reset (Y *p, D d, A a)
template<class Y >
void | reset (shared_ptr< Y > const &r, T *p)
reference | operator* () const
T * | operator-> () const
T * | get () const
bool | unique () const
long | use_count () const
void | swap (shared_ptr< T > &other)
template<class Y >
bool | _internal_less (shared_ptr< Y > const &rhs) const
void * | _internal_get_deleter (detail::sp_typeinfo const &ti) const
bool | _internal_equiv (shared_ptr const &r) const

## Friends

template<class Y >
class | shared_ptr
template<class Y >
class | weak_ptr

The documentation for this class was generated from the following files:

- booster/log.h
- booster/shared_ptr.h